package com.szpg.task;

import com.szpg.db.dao.impl.PgAcuRdcmdDaoImpl;
import com.szpg.db.data.PgAcuRdcmd;
import com.szpg.plc.message.AppCommand;
import com.szpg.plc.message.command.read.ReadWSStatusCommand;
import com.szpg.plc.protocol.DTProtocolInterface;
import com.szpg.plc.protocol.ProtocolFactory;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;

public class ReadWSStatusTask implements Runnable {

	private ACUClient client;
	private AppCommand appCommand;

	public ReadWSStatusTask(ACUClient client, AppCommand command) {
		this.client = client;
		this.appCommand = command;
	}

	@Override
	public void run() {
		DTProtocolInterface finspi = ProtocolFactory.getDefaultDTProtocol();
		byte[] content = finspi.messageToBytes(appCommand);
		
		// 发送读取温湿度参数内存命令
		ACUClientUtil.getInstance().sendACUCommand(client, content);
		
		ReadWSStatusCommand wsAlmCmd = (ReadWSStatusCommand) appCommand;

		// 发送完成之后将命令保存在数据库中
		PgAcuRdcmd cmd = new PgAcuRdcmd();
		cmd.setCmd_type(wsAlmCmd.getCommandType());
		cmd.setDest(wsAlmCmd.getDestinationId());
		cmd.setMem_area_cd(ByteUtil.binToHexString(new byte[] { wsAlmCmd.getMemoryArea() }));
		cmd.setStart_mem_word(wsAlmCmd.getStartAddress().substring(0, 4));
		cmd.setStart_mem_bit(wsAlmCmd.getStartAddress().substring(4));
		cmd.setCount_word(wsAlmCmd.getCountWord());
		cmd.setCount_bit(wsAlmCmd.getCountBit());
		cmd.setCount_sensor(wsAlmCmd.getCountSensor());
		
		new PgAcuRdcmdDaoImpl().addCmdRecord(cmd);
	}

}
